#include <stdlib.h>

#include "node.h"


class Func_system : public Func {
 public:
    NodePtr calculate( NodePtr nod0 ) {
        const Node *v0 = nod0->as_value();
        if( v0->typ()==Node::STR )
            return NodePtr( new NodeInt( system( v0->as_str().c_str() ) ) );
        else
            throw ProgramError( "system() for type "+v0->typ_strg()+" not supported" );
    };
};

class Func_typeof : public Func {
 public:
    NodePtr calculate( NodePtr nod0 ) {
        return NodePtr( new NodeStr( nod0->as_value()->typ_strg() ) );
    };
};


class Func_add : public Func {
 public:
    NodePtr calculate( NodePtr nod0, NodePtr nod1 ) {
        cout << "add calculate\n";
        const Node *v0 = nod0->as_value();
        const Node *v1 = nod1->as_value();
        if     ( v0->typ()==Node::INT && v1->typ()==Node::INT )
            return NodePtr( new NodeInt( v0->as_int() + v1->as_int() ) );
        else if( v0->is_num() && v1->is_num() )
            return NodePtr( new NodeDbl( v0->as_dbl() + v1->as_dbl() ) );
        else if( v0->typ()==Node::STR && v1->typ()==Node::STR )
            return NodePtr( new NodeStr( v0->as_str() + v1->as_str() ) );
        else
            throw ProgramError( "sum of types "+v0->typ_strg()+" and "+v1->typ_strg()+" not supported" );
    };
};


void NFunctions::register_functions()
{
    theFunctions.add_one( FuncPtr(new Func_system()), "system"  );
    theFunctions.add_one( FuncPtr(new Func_typeof()), "typeof"  );
    theFunctions.add_one( FuncPtr(new Func_add()),    "infix +" );
}
