// #include "myexception.h"
#include "value.h"

void Channel::resize( const uint n )
{
    if( is_int() )
        II.resize(n);
    else {
        DD.resize(n);
        if( is_dbl() )
            EE.resize(n);
    }
}

void Channel::cast_to_double()
{
    if( !is_int())
        throw ProgramError( "Channel::cast_to_double: is not int" );
    DD.resize( II.size() );
    for( uint i=0; i<II.size(); ++i ) DD[i] = II[i];
    II.clear();
    retype( VAL_DBL );
}

// Only for legacy read-in.
void Channel::legacy_push_back_int( const int iv )
{
    if        ( is_int() ) {
        II.push_back( iv );
    } else if ( is_dbl() ) {
        DD.push_back( (double) iv );
    } else {
        throw ProgramError(
            "Channel::legacy_push_back(int): dont call when VAL_ERR" );
    }
}

// Only for legacy read-in.
void Channel::legacy_push_back_dbl( const double v )
{
    if        ( is_int() ) {
        cast_to_double();
        DD.push_back( v );
    } else if ( is_dbl() ) {
        DD.push_back( v );
    } else {
        throw ProgramError(
            "Channel::legacy_push_back(int): dont call when VAL_ERR" );
    }
}

uint Channel::size() const
{
    return is_int() ? II.size() : DD.size();
}
