// #include "myexception.h"
#include "value.h"

char valueTypeLetter( ValueType type )
{
    switch( type ){
    case VAL_INT: return 'i';
    case VAL_DBL: return 'd';
    case VAL_ERR: return 'e';
    case VAL_MIX: return '?';
    case VAL_NON: return '-';
    }
}

Value Value::operator- () const
{
    if( is_int() )
        return Value( -i() );
    else if( has_err() )
        return Value( -d(), e() );
    else
        return Value( -d() );
}

Value Value::operator+ ( const Value &v2 ) const
{
    if( is_int() && v2.is_int() )
        return Value( i()+v2.i() );
    else if( has_err() || v2.has_err() )
        return Value( d()+v2.d(), e()+v2.e() );
    else
        return Value( d()+v2.d() );
}

Value Value::operator- ( const Value &v2 ) const
{
    if( is_int() && v2.is_int() )
        return Value( i()-v2.i() );
    else if( has_err() || v2.has_err() )
        return Value( d()-v2.d(), e()+v2.e() );
    else
        return Value( d()-v2.d() );
}

Value Value::operator* ( const Value &v2 ) const
{
    if( is_int() && v2.is_int() )
        return Value( i()*v2.i() );
    else if( has_err() || v2.has_err() )
        return Value( d()*v2.d(), v2.d()*e()+d()*v2.e() );
    else
        return Value( d()*v2.d() );
}

Value Value::operator/ ( const Value &v2 ) const
{
    if( is_int() && v2.is_int() )
        return Value( i()/v2.i() );
    else if( has_err() || v2.has_err() )
        return Value( d()/v2.d(), 1977. );
    else
        return Value( d()/v2.d() );
}

