#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <iostream>
#include <string>
#include <vector>

#include "mystd.h"
#include "range.h"
#include "slice.h"


/*
Spectrum::Spectrum(const vector<double>& X_in, const vector<double>& Y_in,
	     const vector<double>& Z_in)
{
    if (X_in.size() != Y_in.size()) {
        cout << "Spectrum::Make/ incompatible input vectors\n";
        Clear();
        return;
    }
    x = X_in;
    y = Y_in;
    z = Z_in;
}
*/

/*
void Spectrum::push_back(const double x_in, const double y_in)
{
    x.push_back(x_in);
    y.push_back(y_in);
}
*/

/*
void Spectrum::erase(const uint begin, const uint end)
{
    x.erase(x.begin()+begin, x.begin()+end);
    y.erase(y.begin()+begin, y.begin()+end);
}
*/

uint Spectrum::size() const
{
    if (x.size()!=y.size()) {
        printf("PROG ERR scan::size #x [%u] <> #y [%u]\n",
               x.size(), y.size());
        return 0;
    }
    return y.size();
}

CRange Spectrum::get_xrange(const bool logflag) const
{
    double inf=x[0], sup=x[0];
    for (uint i=1; i<size(); i++) {
        if (x[i]<inf) inf=x[i];
        if (x[i]>sup) sup=x[i];
    }
    if (logflag) {
        if (sup<=0) return CRange(2);
        inf = sup;
        for (uint i=1; i<size(); i++) 
            if (x[i]<inf && x[i]>0) inf=x[i];
    }
    return CRange(inf, sup);
}

CRange Spectrum::get_yrange(const bool logflag) const
{
    return get_yrange(CRange(1), logflag);
}

CRange Spectrum::get_yrange(const CRange& xsubrange, const bool logflag) const
{
    bool first=1;
    double inf, sup;
    for (uint i=0; i<size(); i++) {
        if (!xsubrange.contained(x[i])) continue;
        if (first) {
            inf=y[i], sup=y[i];
            first = 0;
        } else {
            if (y[i]<inf) inf=y[i];
            if (y[i]>sup) sup=y[i];
        }
    }
    if (first) {
        cout << "no x in subrange\n";
        return CRange(2);
    }
    if (logflag) {
        if (sup<=0) return CRange(2);
        inf = sup;
        for (uint i=1; i<size(); i++) 
            if (xsubrange.contained(x[i]) &&
                y[i]<inf && y[i]>0) inf=y[i];
    }
    return CRange(inf, sup);
}

void Spectrum::info(void) const
{
    cout << "This scan contains " << size() << " entries\n";
    for (uint i=0; i<size(); i += size()/16)
        printf("%5d %14f %14f\n", i, x[i], y[i]);
    printf("%5d %14f %14f\n", size()-1, x[size()-1], y[size()-1]);
}

void Spectrum::clear(void)
{
    x.clear();
    y.clear();
    z.clear();
}
